///////////////////////////////////////////////////////////////////////////////
// File: DebugTrace.cpp
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All 
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors 
// shall not be liable for any damages suffered by licensee as a result of 
// using the software. In no event will JetByte Limited be liable for any 
// lost revenue, profit or data, or for direct, indirect, special, 
// consequential, incidental or punitive damages, however caused and regardless 
// of the theory of liability, arising out of the use of or inability to use 
// software, even if JetByte Limited has been advised of the possibility of 
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools\Admin\Admin.h"

#include "DebugTrace.h"
#include "SimpleMessageLog.h"

#pragma hdrstop

///////////////////////////////////////////////////////////////////////////////
// Using directives
///////////////////////////////////////////////////////////////////////////////

using JetByteTools::CMessageLog;
using JetByteTools::ILogMessages;

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::Win32
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
namespace Win32 {

///////////////////////////////////////////////////////////////////////////////
// Static variables 
///////////////////////////////////////////////////////////////////////////////

static CSimpleMessageLog s_simpleMessageLog;

///////////////////////////////////////////////////////////////////////////////
// CDebugTrace
///////////////////////////////////////////////////////////////////////////////

CDebugTrace::CDebugTrace()
   :  CMessageLog(s_simpleMessageLog)
{
}

CDebugTrace &CDebugTrace::Instance()
{
   static CDebugTrace theInstance;

   return theInstance;
}

///////////////////////////////////////////////////////////////////////////////
// CDebugTrace::LogInstaller
///////////////////////////////////////////////////////////////////////////////

CDebugTrace::LogInstaller::LogInstaller(
   JetByteTools::ILogMessages &log)
   :  m_pOldLog(CDebugTrace::Instance().SetLog(log))
{

}
      
CDebugTrace::LogInstaller::~LogInstaller()
{
   CDebugTrace::Instance().SetLog(*m_pOldLog);
}

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::Win32
///////////////////////////////////////////////////////////////////////////////

} // End of namespace Win32
} // End of namespace JetByteTools 

///////////////////////////////////////////////////////////////////////////////
// End of file: DebugTrace.cpp
///////////////////////////////////////////////////////////////////////////////
